package lightcontainer.repository;

import lightcontainer.domains.client.StoreProcessor;
import lightcontainer.domains.Task;
import lightcontainer.interfaces.ClientHandlerFFE;
import lightcontainer.interfaces.ProtocolRepository;
import lightcontainer.interfaces.StoreProcessorFFE;

import java.util.Deque;
import java.util.concurrent.ConcurrentLinkedDeque;

public class FileFrontEnd implements ClientHandlerFFE, StoreProcessorFFE {
    // Variables
    private Deque<Task> tasks = new ConcurrentLinkedDeque<>();
    private ClientHandlerRepository clientRepository; // TODO -> pourquoi pas une interface ? end
    private StoreProcessorRepository storeRepository; // TODO -> pourquoi pas une interface ? end
    private ProtocolRepository protocolRepository;

    // Constructor
    public FileFrontEnd(ClientHandlerRepository clientRepo, StoreProcessorRepository storeRepo, ProtocolRepository protocolRepository) {
        this.clientRepository = clientRepo;
        this.storeRepository = storeRepo;
        this.protocolRepository = protocolRepository;
    }

    /**
     * Appelé quand nouvelle tâche
     */
    public void alertStoreProcessors(Task task) {
        // On avertit les stor processors d'une nouvelle tâche
    }

    /**
     * Permet à un {@link StoreProcessor} d'avertir le FFE qu'il est disponible
     *
     * @param store
     */
    @Override
    public void onStoreAvailable(StoreProcessor store) {

    }

    @Override
    public void newCommand(String command, String client) {
        // TODO : Ajouter la tâche - Alerter les StorBackEnds
        Task task = Task.newInstance(command, client);
        tasks.add(task);
    }
}
